package it.tecnologieweb0708.testclasses;

import it.tecnologieweb0708.appclasses.SuperClass;
import junit.framework.TestCase;

/**
 * This is a suite of tests on SuperClass.
 * We leverage JUnit version 3 (not 4, the latest one)
 * because of the Java version in the lab:
 * JUnit4 uses annotations, not naming conventions and inheritance: it requires Java5
 * JUnit3 uses testXXX methods with no args and setUp() and tearDown well-know methods
 * @author pisi79
 */
public class SuperClassTest extends TestCase {

	/**
	 * This is called before each and every test
	 * to initialize the environment (e.g., database table creation)
	 */
	protected void setUp() throws Exception {
		super.setUp();
	}

	/**
	 * This is called after each and every test
	 * to clean the environment (e.g., database table dropping)
	 */
	protected void tearDown() throws Exception {
		super.tearDown();
	}

	// --- Actual tests ----------------------------
	
	/*
	 * Test method for 'it.tecnologieweb0708.appclasses.SuperClass.SuperClass()'
	 * There is no particular logic in the def constructor to test.
	 * By now, we let the test fail explicitly (as a reminder for future work!)
	 */
	public void testSuperClass() {
		// assertions and failing methods are inherited from the test case super class
		// (our test class inherits from it: that's mandatory in JUnit3!)
		super.fail();
		// Later on we could have logic to test or, on the contrary, decide to delete this test completely
		// in case we don't need it.
	}

	/*
	 * Test method for 'it.tecnologieweb0708.appclasses.SuperClass.SuperClass(int)'
	 * Testing methods have no args, so we have to distinguish in other ways between twe two constructors.
	 * That's why the method has the Int suffix.
	 */
	public void testSuperClassInt() {
		int expected = 999;
		SuperClass sc = new SuperClass(expected);
		int actual = sc.getMemberFieldA();
		super.assertEquals("Constructor behaves the right way",expected,actual);
	}
 
	/*
	 * Test method for 'it.tecnologieweb0708.appclasses.SuperClass.getMemberFieldB()'
	 * No one can force us to test one method at a time if it's stupid.... so we just bring
	 * together the getter and setter tests for field B in this sole method
	 */
	public void testGetSetMemberFieldB() {
		// Of course we are testing silly things... Just to see what happens if a test fail.
		int expected = 777;
		SuperClass sc = new SuperClass();
		sc.setMemberFieldB(expected);
		int actual = sc.getMemberFieldB();
		// now we cheat, just to see the failure messages...
		expected = 555;
		// and here is the failure that will warn us about something going bad
		super.assertEquals("B field getter and setter methods test",expected,actual);
	}

}
